FLTK 1.4.4: Fl_Input Class Reference

FLTK 1.4.4

Loading...
Searching...
No Matches
Fl_Input Class Reference

This is the FLTK text input widget. More...

`#include <Fl_Input.H>`

Inheritance diagram for Fl_Input:

## Public Member Functions
| Fl_Input (int, int, int, int, const char *=0)
| Creates a new Fl_Input widget using the given position, size, and label string.
int | handle (int) FL_OVERRIDE
| Handles the specified event.
Public Member Functions inherited from Fl_Input_
int | append (const char *t, int l=0, char keep_selection=0)
| Append text at the end.
bool | can_redo () const
| Check if there is a redo action available.
bool | can_undo () const
| Check if the last operation can be undone.
int | copy (int clipboard)
| Put the current selection into the clipboard.
int | copy_cuts ()
| Copies the yank buffer to the clipboard.
Fl_Color | cursor_color () const
| Gets the color of the cursor.
void | cursor_color (Fl_Color n)
| Sets the color of the cursor.
int | cut ()
| Deletes the current selection.
int | cut (int a, int b)
| Deletes all characters between index `a` and `b`.
int | cut (int n)
| Deletes the next `n` bytes rounded to characters before or after the cursor.
double | dvalue () const
| Returns the widget text interpreted as a floating point number.
| Fl_Input_ (int, int, int, int, const char *=0)
| Creates a new Fl_Input_ widget.
unsigned int | index (int i) const
| Returns the character at index `i`.
int | input_type () const
| Gets the input field type.
void | input_type (int t)
| Sets the input field type.
int | insert (const char *t, int l=0)
| Inserts text at the cursor position.
int | insert_position () const
| Gets the position of the text cursor.
int | insert_position (int p)
| Sets the cursor position and mark.
int | insert_position (int p, int m)
| Sets the index for the cursor and mark.
int | ivalue () const
| Returns the widget text interpreted as a signed integer.
int | mark () const
| Gets the current selection mark.
int | mark (int m)
| Sets the current selection mark.
int | maximum_size () const
| Gets the maximum length of the input field in characters.
void | maximum_size (int m)
| Sets the maximum length of the input field in characters.
int | position () const
int | position (int p)
int | position (int p, int m)
int | readonly () const
| Gets the read-only state of the input field.
void | readonly (int b)
| Sets the read-only state of the input field.
int | redo ()
| Redo previous undo operation.
int | replace (int b, int e, const char *text, int ilen=0)
| Deletes text from `b` to `e` and inserts the new string `text`.
void | resize (int, int, int, int) FL_OVERRIDE
| Changes the size of the widget.
int | shortcut () const
| Return the shortcut key associated with this widget.
void | shortcut (int s)
| Sets the shortcut key associated with this widget.
int | size () const
| Returns the number of bytes in value().
void | size (int W, int H)
| Sets the width and height of this widget.
int | static_value (const char *)
| Changes the widget text.
int | static_value (const char *, int)
| Changes the widget text.
int | tab_nav () const
| Gets whether the Tab key causes focus navigation in multiline input fields or not.
void | tab_nav (int val)
| Sets whether the Tab key does focus navigation, or inserts tab characters into Fl_Multiline_Input.
Fl_Color | textcolor () const
| Gets the color of the text in the input field.
void | textcolor (Fl_Color n)
| Sets the color of the text in the input field.
Fl_Font | textfont () const
| Gets the font of the text in the input field.
void | textfont (Fl_Font s)
| Sets the font of the text in the input field.
Fl_Fontsize | textsize () const
| Gets the size of the text in the input field.
void | textsize (Fl_Fontsize s)
| Sets the size of the text in the input field.
int | undo ()
| Undoes previous changes to the text buffer.
const char * | value () const
| Returns the text displayed in the widget.
int | value (const char *)
| Changes the widget text.
int | value (const char *, int)
| Changes the widget text.
int | value (double value)
| Changes the widget text to a floating point number ("%g").
int | value (int value)
| Changes the widget text to a signed integer number.
int | wrap () const
| Gets the word wrapping state of the input field.
void | wrap (int b)
| Sets the word wrapping state of the input field.
| ~Fl_Input_ ()
| Destroys the widget.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual class Fl_Gl_Window const * | as_gl_window () const
virtual Fl_Group * | as_group ()
| Returns an Fl_Group pointer if this widget is an Fl_Group.
virtual Fl_Group const * | as_group () const
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
virtual Fl_Window const * | as_window () const
void | bind_deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
void | bind_deimage (int f)
| Bind the inactive image to the widget, so the widget will delete the image when it is no longer needed.
void | bind_image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
void | bind_image (int f)
| Bind the image to the widget, so the widget will delete the image when it is no longer needed.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, Fl_Callback_User_Data *p, bool auto_free)
| Sets the current callback function and managed user data for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function and data for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label when in the inactive state.
const Fl_Image * | deimage () const
| Gets the image that is used as part of the widget label when in the inactive state.
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label when in the inactive state.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
int | deimage_bound () const
| Returns whether the inactive image is managed by the widget.
void | do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with default arguments.
void | do_callback (Fl_Widget *widget, long arg, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | do_callback (Fl_Widget *widget, void *arg=0, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual void | hide ()
| Makes a widget invisible.
int | horizontal_label_margin ()
| Get the spacing between the label and the horizontal edge of the widget.
void | horizontal_label_margin (int px)
| Set the spacing between the label and the horizontal edge of the widget.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label when in the active state.
const Fl_Image * | image () const
| Gets the image that is used as part of the widget label when in the active state.
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label when in the active state.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
int | image_bound () const
| Returns whether the image is managed by the widget.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
int | label_image_spacing ()
| Return the gap size between the label and the image.
void | label_image_spacing (int gap)
| Set the gap between the label and the image in pixels.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
bool | needs_keyboard () const
| Returns whether this widget needs a keyboard.
void | needs_keyboard (bool needs)
| Sets whether this widget needs a keyboard.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
int | shortcut_label () const
| Returns whether the widget's label uses '&' to indicate shortcuts.
void | shortcut_label (int value)
| Sets whether the widget's label uses '&' to indicate shortcuts.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (Fl_Callback_User_Data *v, bool auto_free)
| Sets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
int | vertical_label_margin ()
| Get the spacing between the label and the vertical edge of the widget.
void | vertical_label_margin (int px)
| Set the spacing between the label and the vertical edge of the widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus () const
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Static Public Attributes
static const char * | copy_menu_text = "Copy"
| [this text may be customized at run-time]
static const char * | cut_menu_text = "Cut"
| [this text may be customized at run-time]
static const char * | paste_menu_text = "Paste"
| [this text may be customized at run-time]

## Protected Member Functions
void | draw () FL_OVERRIDE
| Draws the widget.
int | handle_key ()
| Handles a keystroke.
int | handle_rmb ()
| Handle right mouse button down events.
Protected Member Functions inherited from Fl_Input_
int | apply_undo ()
| Apply the current undo/redo operation.
void | drawtext (int, int, int, int)
| Draws the text in the passed bounding box.
void | drawtext (int, int, int, int, bool draw_active)
| Draws the text in the passed bounding box.
void | handle_mouse (int, int, int, int, int keepmark=0)
| Handles mouse clicks and mouse moves.
int | handletext (int e, int, int, int, int)
| Handles all kinds of text field related events.
int | line_end (int i) const
| Finds the end of a line.
int | line_start (int i) const
| Finds the start of a line.
int | linesPerPage ()
void | maybe_do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
int | up_down_position (int, int keepmark=0)
| Moves the cursor to the column given by `up_down_pos`.
int | word_end (int i) const
| Finds the end of a word.
int | word_start (int i) const
| Finds the start of a word.
int | xscroll () const
int | yscroll () const
void | yscroll (int yOffset)
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus () const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int X, int Y, int W, int H) const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color bg) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Friends
class | Fl_Cocoa_Screen_Driver
class | Fl_Screen_Driver

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *widget, void *data)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , NEEDS_KEYBOARD = 1<<20 , IMAGE_BOUND = 1<<21 , DEIMAGE_BOUND = 1<<22 , AUTO_DELETE_USER_DATA = 1<<23 , MAXIMIZED = 1<<24 , POPUP = 1<<25 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Detailed Description

This is the FLTK text input widget.

It displays a single line of text and lets the user edit it. Normally it is drawn with an inset box and a white background. The text may contain any characters, and will correctly display any UTF text, using ^X notation for unprintable control characters. It assumes the font can draw any characters of the used scripts, which is true for standard fonts under Windows and Mac OS X. Characters can be input using the keyboard or the character palette/map. Character composition is done using dead keys and/or a compose key as defined by the operating system.

Keyboard and mouse bindings.
Mouse button 1 | Moves the cursor to this point. Drag selects characters. Double click selects words. Triple click selects all line. Shift+click extends the selection. When you select text it is automatically copied to the selection buffer.
Mouse button 2 | Insert the selection buffer at the point clicked. You can also select a region and replace it with the selection buffer by selecting the region with mouse button 2.
Mouse button 3 | Currently acts like button 1.
Backspace | Deletes one character to the left, or deletes the selected region.
Delete | Deletes one character to the right, or deletes the selected region. Combine with Shift for equivalent of ^X (copy+cut).
Enter | May cause the callback, see when().

Platform specific keyboard bindings.
Windows/Linux | Mac | Function
^A | Command-A | Selects all text in the widget.
^C | Command-C | Copy the current selection to the clipboard.
^I | ^I | Insert a tab.
^J | ^J | Insert a Line Feed. (Similar to literal 'Enter' character)
^L | ^L | Insert a Form Feed.
^M | ^M | Insert a Carriage Return.
^V, Shift-Insert | Command-V | Paste the clipboard. (Macs keyboards don't have "Insert" keys, but if they did, Shift-Insert would work)
^X, Shift-Delete | Command-X, Shift-Delete | Cut. Copy the selection to the clipboard and delete it. (If there's no selection, Shift-Delete acts like Delete)
^Z | Command-Z | Undo. This is a single-level undo mechanism, but all adjacent deletions and insertions are concatenated into a single "undo". Often this will undo a lot more than you expected.
Shift-^Z | Shift-Command-Z | Redo. Currently same behavior as ^Z. Reserved for future multilevel undo/redo.
Arrow Keys | Arrow Keys | Standard cursor movement. Can be combined with Shift to extend selection.
Home | Command-Up, Command-Left | Move to start of line. Can be combined with Shift to extend selection.
End | Command-Down, Command-Right | Move to end of line. Can be combined with Shift to extend selection.
Ctrl-Home | Command-Up, Command-PgUp, Ctrl-Left | Move to top of document/field. In single line input, moves to start of line. In multiline input, moves to start of top line. Can be combined with Shift to extend selection.
Ctrl-End | Command-End, Command-PgDn, Ctrl-Right | Move to bottom of document/field. In single line input, moves to end of line. In multiline input, moves to end of last line. Can be combined with Shift to extend selection.
Ctrl-Left | Alt-Left | Word left. Can be combined with Shift to extend selection.
Ctrl-Right | Alt-Right | Word right. Can be combined with Shift to extend selection.
Ctrl-Backspace | Alt-Backspace | Delete word left.
Ctrl-Delete | Alt-Delete | Delete word right.

## Constructor & Destructor Documentation

## ◆ Fl_Input()

Fl_Input::Fl_Input | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | l = 0 )

Creates a new Fl_Input widget using the given position, size, and label string.

The default boxtype is FL_DOWN_BOX.

## Member Function Documentation

## ◆ draw()

void Fl_Input::draw | ( |  | ) |
| protectedvirtual

Draws the widget.

Never call this function directly. FLTK will schedule redrawing whenever needed. If your widget must be redrawn as soon as possible, call redraw() instead.

Override this function to draw your own widgets.

If you ever need to call another widget's draw method from within your own draw() method, e.g. for an embedded scrollbar, you can do it (because draw() is virtual) like this:

Fl_Widget *s = &scrollbar; // scrollbar is an embedded Fl_Scrollbar
s->draw(); // calls Fl_Scrollbar::draw()

Implements Fl_Widget.

## ◆ handle()

int Fl_Input::handle | ( | int | event | ) |
| virtual

Handles the specified event.

You normally don't call this method directly, but instead let FLTK do it when the user interacts with the widget.

When implemented in a widget, this function must return 0 if the widget does not use the event or 1 otherwise.

Most of the time, you want to call the inherited handle() method in your overridden method so that you don't short-circuit events that you don't handle. In this last case you should return the callee retval.

One exception to the rule in the previous paragraph is if you really want to override the behavior of the base class. This requires knowledge of the details of the inherited class.

In rare cases you may want to return 1 from your handle() method although you don't really handle the event. The effect would be to filter event processing, for instance if you want to dismiss non-numeric characters (keypresses) in a numeric input widget. You may "ring the bell" or show another visual indication or drop the event silently. In such a case you must not call the handle() method of the base class and tell FLTK that you consumed the event by returning 1 even if you didn't do anything with it.

Parameters

  [in] | event | the kind of event received

Return values

  0 | if the event was not used or understood
  1 | if the event was used and can be deleted

See also
  Fl_Event

Reimplemented from Fl_Widget.

Reimplemented in Fl_Secret_Input, and Fl_Spinner::Fl_Spinner_Input.

## ◆ handle_key()

int Fl_Input::handle_key | ( |  | ) |
| protected

Handles a keystroke.

This `protected` method handles a keystroke in an Fl_Input or derived class. It handles compose key sequences and can also be used e.g. in Fl_Multiline_Input, Fl_Float_Input and several more derived classes.

The method first checks in Fl::compose if the keystroke is a text entry or a control key. If it is text, the method inserts the composed characters into the input field, taking into account the input type (e.g., numeric fields).

If the keystroke is a control key as determined by Fl::compose, the method handles key combinations for Insert, Enter, and Tab depending on the widget's input_type().

The method then checks for Ctrl key combinations, such as Ctrl-A, Ctrl-C, Ctrl-V, Ctrl-X, and Ctrl-Z, which are commonly used for select all, copy, paste, cut, and undo operations.

Finally, the method checks for ASCII control characters, such as Ctrl-H, Ctrl-I, Ctrl-J, Ctrl-L, and Ctrl-M, which can be used to insert literal control characters into the input field.

If none of the above cases match, the method returns 0, indicating that the keystroke was not handled.

Returns
  1 if the keystroke is handled by us, 0 if not.

## ◆ handle_rmb()

int Fl_Input::handle_rmb | ( |  | ) |
| protected

Handle right mouse button down events.

Returns
  1

The documentation for this class was generated from the following files:

- Fl_Input.H
- Fl_Input.cxx